/*-
 * ~~~~~~licensing~~~~~~
 * cluster-node-management
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.cluster.node.impl;

import com.hazelcast.core.Member;

import ru.entaxy.esb.platform.core.management.cluster.node.Attributes;
import ru.entaxy.esb.platform.core.management.node.NodeDataProvider;

public class MemberAwareDataProvider implements NodeDataProvider {

	protected Member member;
	
	public MemberAwareDataProvider(Member member) {
		super();
		this.member = member;
	}

	@Override
	public String getEntaxyPlatformVersion() {
		return member.getStringAttribute(Attributes.ENTAXY_PLATFORM_VERSION);
	}

	@Override
	public String getHttpPort() {
		return member.getStringAttribute(Attributes.HTTP_PORT);
	}

	@Override
	public String getSshPort() {
		return member.getStringAttribute(Attributes.SSH_PORT);
	}

	@Override
	public boolean isUIEnabled() {
		return member.getBooleanAttribute(Attributes.UI_ENABLED);
	}

	@Override
	public boolean isClusterEnabled() {
		return true;
	}

	@Override
	public String getClusterIP() {
		return member.getAddress().getHost();
	}

	@Override
	public String getClusterPort() {
		return member.getAddress().getPort()+"";
	}
	
	
}
